* lib/inttypes_.h (_LONG_LONG_FORMAT_PREFIX): New macro.
[gnulib.git] / gnulib-tool
index cfe9999..4fb7d5e 100755 (executable)
 
 progname=$0
 package=gnulib
-cvsdatestamp='$Date: 2006-07-31 11:36:29 $'
+cvsdatestamp='$Date: 2006-10-07 14:54:51 $'
 last_checkin_date=`echo "$cvsdatestamp" | sed -e 's,^\$[D]ate: ,,'`
 version=`echo "$last_checkin_date" | sed -e 's/ .*$//' -e 's,/,-,g'`
+nl='
+'
 
 # You can set AUTOCONFPATH to empty if autoconf 2.57 is already in your PATH.
 AUTOCONFPATH=
@@ -99,7 +101,7 @@ Operation modes:
       --extract-filelist           extract the list of files
       --extract-dependencies       extract the dependencies
       --extract-autoconf-snippet   extract the snippet for configure.ac
-      --extract-automake-snippet   extract the snippet for lib/Makefile.am
+      --extract-automake-snippet   extract the snippet for library makefile
       --extract-include-directive  extract the #include directive
       --extract-license            report the license terms of the source files
                                    under lib/
@@ -134,6 +136,9 @@ Options for --import:
                             This option can be repeated.
       --lgpl                Abort if modules aren't available under the LGPL.
                             Also modify license template from GPL to LGPL.
+      --makefile-name=NAME  Name of makefile in automake syntax in the
+                            source-base and tests-base directories
+                            (default \"Makefile.am\").
       --libtool             Use libtool rules.
       --no-libtool          Don't use libtool rules.
       --macro-prefix=PREFIX  Specify the prefix of the macros 'gl_EARLY' and
@@ -152,11 +157,12 @@ Report bugs to <bug-gnulib@gnu.org>."
 func_version ()
 {
   year=`echo "$last_checkin_date" | sed -e 's,/.*$,,'`
-  echo "$progname (GNU $package) $version"
-  echo "Copyright (C) $year Free Software Foundation, Inc.
+  echo "\
+$progname (GNU $package) $version
+Copyright (C) $year Free Software Foundation, Inc.
 This is free software; see the source for copying conditions.  There is NO
-warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
-  echo "Written by" "Bruno Haible" "and" "Simon Josefsson"
+warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+Written by" "Bruno Haible" "and" "Simon Josefsson"
 }
 
 # func_emit_copyright_notice
@@ -174,6 +180,13 @@ func_emit_copyright_notice ()
   echo "# Generated by gnulib-tool."
 }
 
+# func_exit STATUS
+# exit with status
+func_exit ()
+{
+  (exit $1); exit $1
+}
+
 # func_tmpdir
 # creates a temporary directory.
 # Sets variable
@@ -201,17 +214,33 @@ func_tmpdir ()
   } ||
   {
     echo "$0: cannot create a temporary directory in $TMPDIR" >&2
-    { (exit 1); exit 1; }
+    func_exit 1
   }
 }
 
+# func_append var value
+# appends the given value to the shell variable var.
+if ( foo=bar; foo+=baz && test "$foo" = barbaz ) >/dev/null 2>&1; then
+  # Use bash's += operator. It reduces complexity of appending repeatedly to
+  # a single variable from O(n^2) to O(n).
+  func_append ()
+  {
+    eval "$1+=\"\$2\""
+  }
+else
+  func_append ()
+  {
+    eval "$1=\"\$$1\$2\""
+  }
+fi
+
 # func_fatal_error message
 # outputs to stderr a fatal error message, and terminates the program.
 func_fatal_error ()
 {
   echo "gnulib-tool: *** $1" 1>&2
   echo "gnulib-tool: *** Stop." 1>&2
-  exit 1
+  func_exit 1
 }
 
 # func_readlink SYMLINK
@@ -246,10 +275,104 @@ func_ln_if_changed ()
   fi
 }
 
+# func_relativize DIR1 DIR2
+# computes a relative pathname RELDIR such that DIR1/RELDIR = DIR2.
+# Input:
+# - DIR1            relative pathname, relative to the current directory
+# - DIR2            relative pathname, relative to the current directory
+# Output:
+# - reldir          relative pathname of DIR2, relative to DIR1
+func_relativize ()
+{
+  dir0=`pwd`
+  dir1="$1"
+  dir2="$2"
+  sed_first='s,^\([^/]*\)/.*$,\1,'
+  sed_rest='s,^[^/]*/*,,'
+  sed_last='s,^.*/\([^/]*\)$,\1,'
+  sed_butlast='s,/*[^/]*$,,'
+  while test -n "$dir1"; do
+    first=`echo "$dir1" | sed -e "$sed_first"`
+    if test "$first" != "."; then
+      if test "$first" = ".."; then
+        dir2=`echo "$dir0" | sed -e "$sed_last"`/"$dir2"
+        dir0=`echo "$dir0" | sed -e "$sed_butlast"`
+      else
+        first2=`echo "$dir2" | sed -e "$sed_first"`
+        if test "$first2" = "$first"; then
+          dir2=`echo "$dir2" | sed -e "$sed_rest"`
+        else
+          dir2="../$dir2"
+        fi
+        dir0="$dir0"/"$first"
+      fi
+    fi
+    dir1=`echo "$dir1" | sed -e "$sed_rest"`
+  done
+  reldir="$dir2"
+}
+
+# func_relconcat DIR1 DIR2
+# computes a relative pathname DIR1/DIR2, with obvious simplifications.
+# Input:
+# - DIR1            relative pathname, relative to the current directory
+# - DIR2            relative pathname, relative to DIR1
+# Output:
+# - relconcat       DIR1/DIR2, relative to the current directory
+func_relconcat ()
+{
+  dir1="$1"
+  dir2="$2"
+  sed_first='s,^\([^/]*\)/.*$,\1,'
+  sed_rest='s,^[^/]*/*,,'
+  sed_last='s,^.*/\([^/]*\)$,\1,'
+  sed_butlast='s,/*[^/]*$,,'
+  while true; do
+    first=`echo "$dir2" | sed -e "$sed_first"`
+    if test "$first" = "."; then
+      dir2=`echo "$dir2" | sed -e "$sed_rest"`
+      if test -z "$dir2"; then
+        relconcat="$dir1"
+        break
+      fi
+    else
+      last=`echo "$dir1" | sed -e "$sed_last"`
+      while test "$last" = "."; do
+        dir1=`echo "$dir1" | sed -e "$sed_butlast"`
+        last=`echo "$dir1" | sed -e "$sed_last"`
+      done
+      if test -z "$dir1"; then
+        relconcat="$dir2"
+        break
+      fi
+      if test "$first" = ".."; then
+        if test "$last" = ".."; then
+          relconcat="$dir1/$dir2"
+          break
+        fi
+        dir1=`echo "$dir1" | sed -e "$sed_butlast"`
+        dir2=`echo "$dir2" | sed -e "$sed_rest"`
+        if test -z "$dir1"; then
+          relconcat="$dir2"
+          break
+        fi
+        if test -z "$dir2"; then
+          relconcat="$dir1"
+          break
+        fi
+      else
+        relconcat="$dir1/$dir2"
+        break
+      fi
+    fi
+  done
+}
+
 # Command-line option processing.
 # Removes the OPTIONS from the arguments. Sets the variables:
 # - mode            list or import or create-testdir or create-megatestdir
 # - destdir         from --dir
+# - local_gnulib_dir  from --local-dir
 # - libname, supplied_libname  from --lib
 # - sourcebase      from --source-base
 # - m4base          from --m4-base
@@ -259,17 +382,18 @@ func_ln_if_changed ()
 # - inctests        true if --with-tests was given, blank otherwise
 # - avoidlist       list of modules to avoid, from --avoid
 # - lgpl            true if --lgpl was given, blank otherwise
+# - makefile_name   from --makefile-name
 # - libtool         true if --libtool was given, false if --no-libtool was
 #                   given, blank otherwise
 # - macro_prefix    from --macro-prefix
 # - autoconf_minversion  minimum supported autoconf version
 # - do_changelog    false if --no-changelog was given, : otherwise
 # - doit            : if actions shall be executed, false if only to be printed
-# - local_gnulib_dir  from --local-dir
 # - symbolic        true if --symbolic was given, blank otherwise
 {
   mode=
   destdir=
+  local_gnulib_dir=
   libname=libgnu
   supplied_libname=
   sourcebase=
@@ -280,11 +404,11 @@ func_ln_if_changed ()
   inctests=
   avoidlist=
   lgpl=
+  makefile_name=
   libtool=
   macro_prefix=
   do_changelog=:
   doit=:
-  local_gnulib_dir=
   symbolic=
 
   supplied_opts="$@"
@@ -325,6 +449,16 @@ func_ln_if_changed ()
       --dir=* )
         destdir=`echo "X$1" | sed -e 's/^X--dir=//'`
         shift ;;
+      --local-dir )
+        shift
+        if test $# = 0; then
+          func_fatal_error "missing argument for --local-dir"
+        fi
+        local_gnulib_dir=$1
+        shift ;;
+      --local-dir=* )
+        local_gnulib_dir=`echo "X$1" | sed -e 's/^X--local-dir=//'`
+        shift ;;
       --lib )
         shift
         if test $# = 0; then
@@ -395,14 +529,25 @@ func_ln_if_changed ()
         if test $# = 0; then
           func_fatal_error "missing argument for --avoid"
         fi
-        avoidlist="$avoidlist $1"
+        func_append avoidlist " $1"
         shift ;;
       --avoid=* )
-        avoidlist="$avoidlist "`echo "X$1" | sed -e 's/^X--avoid=//'`
+        arg=`echo "X$1" | sed -e 's/^X--avoid=//'`
+        func_append avoidlist " $arg"
         shift ;;
       --lgpl )
         lgpl=true
         shift ;;
+      --makefile-name )
+        shift
+        if test $# = 0; then
+          func_fatal_error "missing argument for --makefile-name"
+        fi
+        makefile_name="$1"
+        shift ;;
+      --makefile-name=* )
+        makefile_name=`echo "X$1" | sed -e 's/^X--makefile-name=//'`
+        shift ;;
       --libtool )
         libtool=true
         shift ;;
@@ -425,25 +570,15 @@ func_ln_if_changed ()
       --dry-run )
         doit=false
         shift ;;
-      --local-dir )
-        shift
-        if test $# = 0; then
-          func_fatal_error "missing argument for --local-dir"
-        fi
-        local_gnulib_dir=$1
-        shift ;;
-      --local-dir=* )
-        local_gnulib_dir=`echo "X$1" | sed -e 's/^X--local-dir=//'`
-        shift ;;
       -s | --symbolic | --symboli | --symbol | --symbo | --symb | --symlink | --symlin | --symli | --syml | --sym | --sy )
         symbolic=true
         shift ;;
       --help | --hel | --he | --h )
         func_usage
-        exit 0 ;;
+        func_exit $? ;;
       --version | --versio | --versi | --vers | --ver | --ve | --v )
         func_version
-        exit 0 ;;
+        func_exit $? ;;
       -- )
         # Stop option processing
         shift
@@ -451,7 +586,7 @@ func_ln_if_changed ()
       -* )
         echo "gnulib-tool: unknown option $1" 1>&2
         echo "Try 'gnulib-tool --help' for more information." 1>&2
-        exit 1 ;;
+        func_exit 1 ;;
       * )
         break ;;
     esac
@@ -463,17 +598,18 @@ func_ln_if_changed ()
       echo "Try 'gnulib-tool --help' for more information." 1>&2
       echo "If you really want to modify the gnulib configuration of your project," 1>&2
       echo "you need to use 'gnulib --import' - at your own risk!" 1>&2
-      exit 1
+      func_exit 1
     fi
-    if test -n "$supplied_libname" || test -n "$sourcebase" || test -n "$m4base" \
+    if test -n "$local_gnulib_dir" || test -n "$supplied_libname" \
+       || test -n "$sourcebase" || test -n "$m4base" \
        || test -n "$docbase" || test -n "$testsbase" || test -n "$auxdir" \
        || test -n "$inctests" || test -n "$avoidlist" || test -n "$lgpl" \
-       || test -n "$macro_prefix"; then
+       || test -n "$makefile_name" || test -n "$macro_prefix"; then
       echo "gnulib-tool: invalid options for 'update' mode" 1>&2
       echo "Try 'gnulib-tool --help' for more information." 1>&2
       echo "If you really want to modify the gnulib configuration of your project," 1>&2
       echo "you need to use 'gnulib --import' - at your own risk!" 1>&2
-      exit 1
+      func_exit 1
     fi
     do_changelog=false
   fi
@@ -516,7 +652,7 @@ func_ln_if_changed ()
       }'
     eval `sed -n -e "$my_sed_traces" < "$configure_ac"`
     if test -n "$prereqs"; then
-      autoconf_minversion=`for version in $prereqs; do echo $version; done | $SORT -g | uniq | tail -1`
+      autoconf_minversion=`for version in $prereqs; do echo $version; done | $SORT -g -u | tail -1`
     fi
   fi
   if test -z "$autoconf_minversion"; then
@@ -530,6 +666,9 @@ func_ln_if_changed ()
   # Remove trailing slashes from the directory names. This is necessary for
   # m4base (to avoid an error in func_import) and optional for the others.
   sed_trimtrailingslashes='s,\([^/]\)//*$,\1,'
+  case "$local_gnulib_dir" in
+    */ ) sourcebase=`echo "$local_gnulib_dir" | sed -e "$sed_trimtrailingslashes"` ;;
+  esac
   case "$sourcebase" in
     */ ) sourcebase=`echo "$sourcebase" | sed -e "$sed_trimtrailingslashes"` ;;
   esac
@@ -573,11 +712,22 @@ done
 gnulib_dir=`echo "$self_abspathname" | sed -e 's,/[^/]*$,,'`
 
 func_tmpdir
-trap 'rm -rf "$tmp"' 0 1 2 3 15
+trap 'exit_status=$?
+      if test "$signal" != 0; then
+        echo "caught signal $signal" >&2
+      fi
+      rm -rf "$tmp"
+      exit $exit_status' 0
+for signal in 1 2 3 13 15; do
+  trap '{ signal='$signal'; func_exit 1; }' $signal
+done
+signal=0
 
 # func_lookup_file file
 # looks up a file in $local_gnulib_dir or $gnulib_dir, or combines it through
 # 'patch'.
+# Input:
+# - local_gnulib_dir  from --local-dir
 # Output:
 # - lookedup_file   name of the merged (combined) file
 # - lookedup_tmp    true if it is located in the tmp directory, blank otherwise
@@ -608,6 +758,8 @@ func_lookup_file ()
 }
 
 # func_all_modules
+# Input:
+# - local_gnulib_dir  from --local-dir
 func_all_modules ()
 {
   # Filter out metainformation files like README, which are not modules.
@@ -619,24 +771,31 @@ func_all_modules ()
       (cd "$local_gnulib_dir/modules" && ls -1 | sed -e 's,\.diff$,,')
     fi
   } \
-      | sed -e '/^CVS$/d' -e '/^ChangeLog$/d' -e '/^README$/d' -e '/^TEMPLATE$/d' -e '/^TEMPLATE-TESTS$/d' -e '/~$/d' \
+      | sed -e '/^CVS$/d' -e '/^ChangeLog$/d' -e '/^COPYING$/d' -e '/^README$/d' -e '/^TEMPLATE$/d' -e '/^TEMPLATE-TESTS$/d' -e '/~$/d' \
       | sed -e '/-tests$/d' \
-      | LC_ALL=C sort \
-      | LC_ALL=C uniq
+      | LC_ALL=C sort -u
 }
 
 # func_verify_module
 # verifies a module name
+# Input:
+# - local_gnulib_dir  from --local-dir
+# - module          module name argument
 func_verify_module ()
 {
-  if ! { test -f "$gnulib_dir/modules/$module" \
-         || { test -n "$local_gnulib_dir" && test -d "$local_gnulib_dir/modules" \
-              && test -f "$local_gnulib_dir/modules/$module"; }; } \
-     || test "CVS" = "$module" \
-     || test "ChangeLog" = "$module" \
-     || test "README" = "$module" \
-     || test "TEMPLATE" = "$module" \
-     || test "TEMPLATE-TESTS" = "$module"; then
+  if { test -f "$gnulib_dir/modules/$module" \
+       || { test -n "$local_gnulib_dir" && test -d "$local_gnulib_dir/modules" \
+            && test -f "$local_gnulib_dir/modules/$module"; }; } \
+     && test "CVS" != "$module" \
+     && test "ChangeLog" != "$module" \
+     && test "COPYING" != "$module" \
+     && test "README" != "$module" \
+     && test "TEMPLATE" != "$module" \
+     && test "TEMPLATE-TESTS" != "$module"; then
+    # OK, $module is a correct module name.
+    # Verify that building the module description with 'patch' succeeds.
+    func_lookup_file "modules/$module"
+  else
     echo "gnulib-tool: module $module doesn't exist" 1>&2
     module=
   fi
@@ -644,6 +803,9 @@ func_verify_module ()
 
 # func_verify_nontests_module
 # verifies a module name, excluding tests modules
+# Input:
+# - local_gnulib_dir  from --local-dir
+# - module          module name argument
 func_verify_nontests_module ()
 {
   case "$module" in
@@ -654,6 +816,9 @@ func_verify_nontests_module ()
 
 # func_verify_tests_module
 # verifies a module name, considering only tests modules
+# Input:
+# - local_gnulib_dir  from --local-dir
+# - module          module name argument
 func_verify_tests_module ()
 {
   case "$module" in
@@ -680,6 +845,8 @@ sed_extract_prog=':[         ]*$/ {
 }'
 
 # func_get_description module
+# Input:
+# - local_gnulib_dir  from --local-dir
 func_get_description ()
 {
   func_lookup_file "modules/$1"
@@ -687,6 +854,8 @@ func_get_description ()
 }
 
 # func_get_filelist module
+# Input:
+# - local_gnulib_dir  from --local-dir
 func_get_filelist ()
 {
   func_lookup_file "modules/$1"
@@ -700,6 +869,8 @@ func_get_filelist ()
 }
 
 # func_get_dependencies module
+# Input:
+# - local_gnulib_dir  from --local-dir
 func_get_dependencies ()
 {
   # ${module}-tests always implicitly depends on ${module}.
@@ -710,6 +881,8 @@ func_get_dependencies ()
 }
 
 # func_get_autoconf_snippet module
+# Input:
+# - local_gnulib_dir  from --local-dir
 func_get_autoconf_snippet ()
 {
   func_lookup_file "modules/$1"
@@ -717,6 +890,8 @@ func_get_autoconf_snippet ()
 }
 
 # func_get_automake_snippet module
+# Input:
+# - local_gnulib_dir  from --local-dir
 func_get_automake_snippet ()
 {
   func_lookup_file "modules/$1"
@@ -724,6 +899,8 @@ func_get_automake_snippet ()
 }
 
 # func_get_include_directive module
+# Input:
+# - local_gnulib_dir  from --local-dir
 func_get_include_directive ()
 {
   func_lookup_file "modules/$1"
@@ -732,6 +909,8 @@ func_get_include_directive ()
 }
 
 # func_get_license module
+# Input:
+# - local_gnulib_dir  from --local-dir
 func_get_license ()
 {
   func_lookup_file "modules/$1"
@@ -739,6 +918,8 @@ func_get_license ()
 }
 
 # func_get_maintainer module
+# Input:
+# - local_gnulib_dir  from --local-dir
 func_get_maintainer ()
 {
   func_lookup_file "modules/$1"
@@ -746,10 +927,14 @@ func_get_maintainer ()
 }
 
 # func_get_tests_module module
+# Input:
+# - local_gnulib_dir  from --local-dir
 func_get_tests_module ()
 {
   # The naming convention for tests modules is hardwired: ${module}-tests.
-  if test -f modules/"$1"-tests; then
+  if test -f "$gnulib_dir/modules/$1"-tests \
+     || { test -n "$local_gnulib_dir" && test -d "$local_gnulib_dir/modules" \
+          && test -f "$local_gnulib_dir/modules/$1"-tests; }; then
     echo "$1"-tests
   fi
 }
@@ -770,56 +955,59 @@ func_acceptable ()
 
 # func_modules_transitive_closure
 # Input:
+# - local_gnulib_dir  from --local-dir
 # - modules         list of specified modules
 # - inctests        true if tests should be included, blank otherwise
 # - avoidlist       list of modules to avoid
+# - tmp             pathname of a temporary directory
 # Output:
 # - modules         list of modules, including dependencies
 func_modules_transitive_closure ()
 {
-  while true; do
-    xmodules=
-    for module in $modules; do
+  # In order to process every module only once (for speed), process an "input
+  # list" of modules, producing an "output list" of modules. During each round,
+  # more modules can be queued in the input list. Once a module on the input
+  # list has been processed, it is added to the "handled list", so we can avoid
+  # to process it again.
+  handledmodules=
+  inmodules="$modules"
+  outmodules=
+  while test -n "$inmodules"; do
+    inmodules_this_round="$inmodules"
+    inmodules=                    # Accumulator, queue for next round
+    for module in $inmodules_this_round; do
       func_verify_module
       if test -n "$module"; then
-        # Duplicate dependencies are harmless, but Jim wants a warning.
-        duplicated_deps=`func_get_dependencies $module | LC_ALL=C sort | LC_ALL=C uniq -d`
-        if test -n "$duplicated_deps"; then
-          echo "warning: module $module has duplicated dependencies: "`echo $duplicated_deps` 1>&2
-        fi
         if func_acceptable $module; then
-          xmodules="$xmodules $module"
-          for depmodule in `func_get_dependencies $module`; do
-            if func_acceptable $depmodule; then
-              xmodules="$xmodules $depmodule"
-            fi
-          done
+          func_append outmodules " $module"
+          deps=`func_get_dependencies $module`
+          # Duplicate dependencies are harmless, but Jim wants a warning.
+          duplicated_deps=`echo "$deps" | LC_ALL=C sort | LC_ALL=C uniq -d`
+          if test -n "$duplicated_deps"; then
+            echo "warning: module $module has duplicated dependencies: "`echo $duplicated_deps` 1>&2
+          fi
+          func_append inmodules " $deps"
           if test -n "$inctests"; then
             testsmodule=`func_get_tests_module $module`
             if test -n "$testsmodule"; then
-              if func_acceptable $testsmodule; then
-                xmodules="$xmodules $testsmodule"
-                for depmodule in `func_get_dependencies $testsmodule`; do
-                  if func_acceptable $depmodule; then
-                    xmodules="$xmodules $depmodule"
-                  fi
-                done
-              fi
+              func_append inmodules " $testsmodule"
             fi
           fi
         fi
       fi
     done
-    xmodules=`for m in $xmodules; do echo $m; done | LC_ALL=C sort | LC_ALL=C uniq`
-    if test "$xmodules" = "$modules"; then
-      break
-    fi
-    modules="$xmodules"
+    handledmodules=`for m in $handledmodules $inmodules_this_round; do echo $m; done | LC_ALL=C sort -u`
+    # Remove $handledmodules from $inmodules.
+    for m in $inmodules; do echo $m; done | LC_ALL=C sort -u > "$tmp"/queued-modules
+    inmodules=`echo "$handledmodules" | LC_ALL=C join -v 2 - "$tmp"/queued-modules`
   done
+  modules=`for m in $outmodules; do echo $m; done | LC_ALL=C sort -u`
+  rm -f "$tmp"/queued-modules
 }
 
 # func_modules_add_dummy
 # Input:
+# - local_gnulib_dir  from --local-dir
 # - modules         list of modules, including dependencies
 # Output:
 # - modules         list of modules, including 'dummy' if needed
@@ -848,12 +1036,13 @@ ba
   done
   # Add the dummy module, to make sure the library will be non-empty.
   if test -z "$have_lib_SOURCES"; then
-    modules="$modules dummy"
+    func_append modules " dummy"
   fi
 }
 
 # func_modules_to_filelist
 # Input:
+# - local_gnulib_dir  from --local-dir
 # - modules         list of modules, including dependencies
 # Output:
 # - files           list of files
@@ -863,91 +1052,135 @@ func_modules_to_filelist ()
   for module in $modules; do
     func_verify_module
     if test -n "$module"; then
-      files="$files "`func_get_filelist $module`
+      fs=`func_get_filelist $module`
+      func_append files " $fs"
     fi
   done
-  files=`for f in $files; do echo $f; done | LC_ALL=C sort | LC_ALL=C uniq`
+  files=`for f in $files; do echo $f; done | LC_ALL=C sort -u`
 }
 
 # func_emit_lib_Makefile_am
-# emits the contents of lib/Makefile.am to standard output.
+# emits the contents of library makefile to standard output.
 # Input:
+# - local_gnulib_dir  from --local-dir
 # - modules         list of modules, including dependencies
 # - libname         library name
+# - makefile_name   from --makefile-name
 # - libtool         true if libtool will be used, false or blank otherwise
 # - actioncmd       (optional) command that will reproduce this invocation
 func_emit_lib_Makefile_am ()
 {
+  # When creating an includable Makefile.am snippet, augment variables with
+  # += instead of assigning them.
+  if test -n "$makefile_name"; then
+    assign='+='
+  else
+    assign='='
+  fi
   if test "$libtool" = true; then
     libext=la
     perhapsLT=LT
+    sed_eliminate_LDFLAGS=
   else
     libext=a
     perhapsLT=
+    sed_eliminate_LDFLAGS='/^lib_LDFLAGS[       ]*+=/d'
   fi
+  echo "## DO NOT EDIT! GENERATED AUTOMATICALLY!"
   echo "## Process this file with automake to produce Makefile.in."
   func_emit_copyright_notice
   if test -n "$actioncmd"; then
     echo "# Reproduce by: $actioncmd"
   fi
   echo
-  # No need to generate dependencies since the sources are in gnulib, not here.
-  echo "AUTOMAKE_OPTIONS = 1.5 gnits no-dependencies"
-  echo
-  echo "noinst_${perhapsLT}LIBRARIES = $libname.$libext"
-  echo
-  echo "${libname}_${libext}_SOURCES ="
-  echo "${libname}_${libext}_LIBADD = @${perhapsLT}LIBOBJS@"
-  echo "noinst_HEADERS ="
-  echo "EXTRA_DIST ="
-  echo "BUILT_SOURCES ="
-  echo "SUFFIXES ="
-  echo "MOSTLYCLEANFILES ="
-  echo "MOSTLYCLEANDIRS ="
-  echo "CLEANFILES ="
-  echo "DISTCLEANFILES ="
-  echo "MAINTAINERCLEANFILES ="
-  echo
-  echo "AM_CPPFLAGS ="
+  if test -z "$makefile_name"; then
+    echo "AUTOMAKE_OPTIONS = 1.5 gnits"
+  fi
   echo
-  for module in $modules; do
-    func_verify_nontests_module
-    if test -n "$module"; then
-      {
-        func_get_automake_snippet "$module" |
-          sed -e 's,lib_\([A-Z][A-Z]*\),'"${libname}_${libext}"'_\1,g'
-        if test "$module" = 'alloca'; then
-          echo "${libname}_${libext}_LIBADD += @${perhapsLT}ALLOCA@"
+  (
+    for module in $modules; do
+      func_verify_nontests_module
+      if test -n "$module"; then
+        {
+          func_get_automake_snippet "$module" |
+            sed -e 's,lib_LIBRARIES,lib%_LIBRARIES,g' \
+                -e 's,lib_LTLIBRARIES,lib%_LTLIBRARIES,g' |
+            sed -e "$sed_eliminate_LDFLAGS" |
+            sed -e 's,lib_\([A-Z][A-Z]*\),'"${libname}_${libext}"'_\1,g' |
+            sed -e 's,lib%_LIBRARIES,lib_LIBRARIES,g' \
+                -e 's,lib%_LTLIBRARIES,lib_LTLIBRARIES,g'
+          if test "$module" = 'alloca'; then
+            echo "${libname}_${libext}_LIBADD += @${perhapsLT}ALLOCA@"
+          fi
+        } > amsnippet.tmp
+        # Skip the contents if its entirely empty.
+        if grep '[^     ]' amsnippet.tmp > /dev/null ; then
+          echo "## begin gnulib module $module"
+          echo
+          cat amsnippet.tmp
+          echo "## end   gnulib module $module"
+          echo
         fi
-      } > amsnippet.tmp
-      # Skip the contents if its entirely empty.
-      if grep '[^       ]' amsnippet.tmp > /dev/null ; then
-        echo "## begin gnulib module $module"
-        echo
-        cat amsnippet.tmp
-        echo "## end   gnulib module $module"
-        echo
+        rm -f amsnippet.tmp
       fi
-      rm -f amsnippet.tmp
+    done
+  ) > allsnippets.tmp
+  if grep "^[a-zA-Z0-9_]*_${perhapsLT}LIBRARIES *= *$libname\\.$libext\$" allsnippets.tmp > /dev/null; then
+    # One of the snippets already specifies an installation location for the
+    # library. Don't confuse automake by saying it should not be installed.
+    :
+  else
+    # By default, the generated library should not be installed.
+    echo "noinst_${perhapsLT}LIBRARIES $assign $libname.$libext"
+  fi
+  echo
+  echo "${libname}_${libext}_SOURCES ="
+  # Here we use $(LIBOBJS), not @LIBOBJS@. The value is the same. However,
+  # automake during its analyses looks for $(LIBOBJS), not for @LIBOBJS@.
+  echo "${libname}_${libext}_LIBADD = \$(${perhapsLT}LIBOBJS)"
+  if test "$libtool" = true; then
+    echo "${libname}_${libext}_LDFLAGS = \$(AM_LDFLAGS)"
+  fi
+  if test -z "$makefile_name"; then
+    echo "noinst_HEADERS ="
+    # Automake versions < 1.9b create an empty pkgdatadir at installation time
+    # if you specify pkgdata_DATA to empty. This is a workaround.
+    if grep '^pkgdata_DATA *+=' allsnippets.tmp > /dev/null; then
+      echo "pkgdata_DATA ="
     fi
-  done
+    echo "EXTRA_DIST ="
+    echo "BUILT_SOURCES ="
+    echo "SUFFIXES ="
+  fi
+  echo "MOSTLYCLEANFILES $assign core *.stackdump"
+  if test -z "$makefile_name"; then
+    echo "MOSTLYCLEANDIRS ="
+    echo "CLEANFILES ="
+    echo "DISTCLEANFILES ="
+    echo "MAINTAINERCLEANFILES ="
+    echo
+    echo "AM_CPPFLAGS ="
+  fi
+  echo
+  cat allsnippets.tmp
   echo
-  echo "mostlyclean-local:"
+  echo "mostlyclean-local: mostlyclean-generic"
   echo "       @test -z \"\$(MOSTLYCLEANDIRS)\" || \\"
   echo "         for dir in \$(MOSTLYCLEANDIRS); do \\"
   echo "           if test -d \$\$dir; then \\"
   echo "             echo \"rmdir \$\$dir\"; rmdir \$\$dir; \\"
   echo "           fi; \\"
   echo "         done"
-  echo
-  echo "# Makefile.am ends here"
+  rm -f allsnippets.tmp
 }
 
 # func_emit_tests_Makefile_am
-# emits the contents of tests/Makefile.am to standard output.
+# emits the contents of tests makefile to standard output.
 # Input:
+# - local_gnulib_dir  from --local-dir
 # - modules         list of modules, including dependencies
 # - libname         library name
+# - makefile_name   from --makefile-name
 # - libtool         true if libtool will be used, false or blank otherwise
 # - sourcebase      relative directory containing lib source code
 # - m4base          relative directory containing autoconf macros
@@ -959,7 +1192,15 @@ func_emit_tests_Makefile_am ()
   else
     libext=a
   fi
+  if test "$libtool" = true; then
+    libext=la
+    sed_eliminate_LDFLAGS=
+  else
+    libext=a
+    sed_eliminate_LDFLAGS='/^lib_LDFLAGS[       ]*+=/d'
+  fi
   testsbase_inverse=`echo "$testsbase" | sed -e 's,/$,,' | sed -e 's,[^/][^/]*,..,g'`
+  echo "## DO NOT EDIT! GENERATED AUTOMATICALLY!"
   echo "## Process this file with automake to produce Makefile.in."
   func_emit_copyright_notice
   echo
@@ -968,6 +1209,31 @@ func_emit_tests_Makefile_am ()
   echo
   echo "ACLOCAL_AMFLAGS = -I ${testsbase_inverse}/${m4base}"
   echo
+  (
+    for module in $modules; do
+      func_verify_tests_module
+      if test -n "$module"; then
+        {
+          func_get_automake_snippet "$module" |
+            sed -e 's,lib_LIBRARIES,lib%_LIBRARIES,g' \
+                -e 's,lib_LTLIBRARIES,lib%_LTLIBRARIES,g' |
+            sed -e "$sed_eliminate_LDFLAGS" |
+            sed -e 's,lib_\([A-Z][A-Z]*\),'"${libname}_${libext}"'_\1,g' |
+            sed -e 's,lib%_LIBRARIES,lib_LIBRARIES,g' \
+                -e 's,lib%_LTLIBRARIES,lib_LTLIBRARIES,g'
+        } > amsnippet.tmp
+        # Skip the contents if its entirely empty.
+        if grep '[^     ]' amsnippet.tmp > /dev/null ; then
+          echo "## begin gnulib module $module"
+          echo
+          cat amsnippet.tmp
+          echo "## end   gnulib module $module"
+          echo
+        fi
+        rm -f amsnippet.tmp
+      fi
+    done
+  ) > allsnippets.tmp
   # Nothing is being added to SUBDIRS; nevertheless the existence of this
   # variable is needed to avoid an error from automake:
   #   "AM_GNU_GETTEXT used but SUBDIRS not defined"
@@ -977,10 +1243,13 @@ func_emit_tests_Makefile_am ()
   echo "noinst_PROGRAMS ="
   echo "check_PROGRAMS ="
   echo "noinst_HEADERS ="
+  if grep '^pkgdata_DATA *+=' allsnippets.tmp > /dev/null; then
+    echo "pkgdata_DATA ="
+  fi
   echo "EXTRA_DIST ="
   echo "BUILT_SOURCES ="
   echo "SUFFIXES ="
-  echo "MOSTLYCLEANFILES ="
+  echo "MOSTLYCLEANFILES = core *.stackdump"
   echo "MOSTLYCLEANDIRS ="
   echo "CLEANFILES ="
   echo "DISTCLEANFILES ="
@@ -993,39 +1262,25 @@ func_emit_tests_Makefile_am ()
   echo
   echo "LDADD = ${testsbase_inverse}/${sourcebase-lib}/${libname}.${libext}"
   echo
-  for module in $modules; do
-    func_verify_tests_module
-    if test -n "$module"; then
-      func_get_automake_snippet "$module" > amsnippet.tmp
-      # Skip the contents if its entirely empty.
-      if grep '[^       ]' amsnippet.tmp > /dev/null ; then
-        echo "## begin gnulib module $module"
-        echo
-        cat amsnippet.tmp
-        echo "## end   gnulib module $module"
-        echo
-      fi
-      rm -f amsnippet.tmp
-    fi
-  done
+  cat allsnippets.tmp
   echo "# Clean up after Solaris cc."
   echo "clean-local:"
   echo "       rm -rf SunWS_cache"
   echo
-  echo "mostlyclean-local:"
+  echo "mostlyclean-local: mostlyclean-generic"
   echo "       @test -z \"\$(MOSTLYCLEANDIRS)\" || \\"
   echo "         for dir in \$(MOSTLYCLEANDIRS); do \\"
   echo "           if test -d \$\$dir; then \\"
   echo "             echo \"rmdir \$\$dir\"; rmdir \$\$dir; \\"
   echo "           fi; \\"
   echo "         done"
-  echo
-  echo "# Makefile.am ends here"
+  rm -f allsnippets.tmp
 }
 
 # func_import modules
 # Uses also the variables
 # - destdir         target directory
+# - local_gnulib_dir  from --local-dir
 # - libname         library name
 # - sourcebase      directory relative to destdir where to place source code
 # - m4base          directory relative to destdir where to place *.m4 macros
@@ -1035,6 +1290,7 @@ func_emit_tests_Makefile_am ()
 # - inctests        true if --with-tests was given, blank otherwise
 # - avoidlist       list of modules to avoid, from --avoid
 # - lgpl            true if library's license shall be LGPL, blank otherwise
+# - makefile_name   from --makefile-name
 # - libtool         true if --libtool was given, false if --no-libtool was
 #                   given, blank otherwise
 # - guessed_libtool true if the configure.ac file uses libtool, false otherwise
@@ -1045,6 +1301,7 @@ func_emit_tests_Makefile_am ()
 func_import ()
 {
   # Get the cached settings.
+  cached_local_gnulib_dir=
   cached_specified_modules=
   cached_avoidlist=
   cached_sourcebase=
@@ -1053,6 +1310,7 @@ func_import ()
   cached_testsbase=
   cached_libname=
   cached_lgpl=
+  cached_makefile_name=
   cached_libtool=
   cached_macro_prefix=
   cached_files=
@@ -1062,6 +1320,9 @@ func_import ()
       s,#.*$,,
       s,^dnl .*$,,
       s, dnl .*$,,
+      /gl_LOCAL_DIR(/ {
+        s,^.*gl_LOCAL_DIR([[ ]*\([^])]*\).*$,cached_local_gnulib_dir="\1",p
+      }
       /gl_MODULES(/ {
         s,^.*gl_MODULES([[ ]*\([^])]*\).*$,cached_specified_modules="\1",p
       }
@@ -1086,6 +1347,9 @@ func_import ()
       /gl_LGPL/ {
         s,^.*$,cached_lgpl=true,p
       }
+      /gl_MAKEFILE_NAME(/ {
+        s,^.*gl_MAKEFILE_NAME([[ ]*\([^])]*\).*$,cached_makefile_name="\1",p
+      }
       /gl_LIBTOOL/ {
         s,^.*$,cached_libtool=true,p
       }
@@ -1120,6 +1384,24 @@ func_import ()
   if test -n "$cached_m4base" && test "$cached_m4base" != "$m4base"; then
     func_fatal_error "$m4base/gnulib-cache.m4 is expected to contain gl_M4_BASE([$m4base])"
   fi
+  # The local_gnulib_dir defaults to the cached one. Recall that the cached one
+  # is relative to $destdir, whereas the one we use is relative to . or absolute.
+  if test -z "$local_gnulib_dir"; then
+    if test -n "$cached_local_gnulib_dir"; then
+      case "$destdir" in
+        /*)
+          local_gnulib_dir="$destdir/$cached_local_gnulib_dir" ;;
+        *)
+          case "$cached_local_gnulib_dir" in
+            /*)
+              local_gnulib_dir="$destdir/$cached_local_gnulib_dir" ;;
+            *)
+              func_relconcat "$destdir" "$cached_local_gnulib_dir"
+              local_gnulib_dir="$relconcat" ;;
+          esac ;;
+      esac
+    fi
+  fi
   # Append the cached and the specified module names. So that
   # "gnulib-tool --import foo" means to add the module foo.
   specified_modules="$cached_specified_modules $1"
@@ -1158,6 +1440,10 @@ func_import ()
   if test -z "$lgpl"; then
     lgpl="$cached_lgpl"
   fi
+  # The makefile_name defaults to the cached one.
+  if test -z "$makefile_name"; then
+    makefile_name="$cached_makefile_name"
+  fi
   # Use libtool if specified either way, or if guessed.
   if test -z "$libtool"; then
     if test -n "$cached_m4base"; then
@@ -1175,7 +1461,7 @@ func_import ()
   fi
 
   # Canonicalize the list of specified modules.
-  specified_modules=`for m in $specified_modules; do echo $m; done | LC_ALL=C sort | LC_ALL=C uniq`
+  specified_modules=`for m in $specified_modules; do echo $m; done | LC_ALL=C sort -u`
 
   # Determine final module list.
   modules="$specified_modules"
@@ -1186,17 +1472,37 @@ func_import ()
   # Add the dummy module if needed.
   func_modules_add_dummy
 
-  # If --lgpl, check the license of modules are compatible.
+  # If --lgpl, verify that the licenses of modules are compatible.
   if test -n "$lgpl"; then
     for module in $modules; do
       license=`func_get_license $module`
       case $license in
-        LGPL | 'GPLed build tool' | 'public domain' | 'unlimited') ;;
+        LGPL | 'GPLed build tool') ;;
+        'public domain' | 'unlimited' | 'unmodifiable license text') ;;
         *) func_fatal_error "incompatible license on module $module: $license" ;;
       esac
     done
   fi
 
+  # Determine script to apply to imported library files.
+  sed_transform_lib_file=
+  for module in $modules; do
+    if test $module = config-h; then
+      # Assume config.h exists, and that -DHAVE_CONFIG_H is omitted.
+      sed_transform_lib_file=$sed_transform_lib_file'
+        s/^#ifdef[      ]*HAVE_CONFIG_H[        ]*$/#if 1/
+      '
+      break
+    fi
+  done
+  if test -n "$lgpl"; then
+    # Update license.
+    sed_transform_lib_file=$sed_transform_lib_file'
+      s/GNU General/GNU Lesser General/g
+      s/version 2\([ ,]\)/version 2.1\1/g
+    '
+  fi
+
   # Determine final file list.
   func_modules_to_filelist
   echo "File list:"
@@ -1209,7 +1515,7 @@ func_import ()
   new_files="$files m4/gnulib-tool.m4"
   old_files="$cached_files"
   if test -f "$destdir"/$m4base/gnulib-tool.m4; then
-    old_files="$old_files m4/gnulib-tool.m4"
+    func_append old_files " m4/gnulib-tool.m4"
   fi
 
   # Create directories.
@@ -1278,28 +1584,30 @@ func_import ()
 
   # Copy files or make symbolic links. Remove obsolete files.
   delimiter='  '
-  for f in $old_files; do
-    case "$f" in
-      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
-      doc/*) g=`echo "$f" | sed -e "s,^doc/,$cached_docbase/,"` ;;
-      lib/*) g=`echo "$f" | sed -e "s,^lib/,$cached_sourcebase/,"` ;;
-      m4/*) g=`echo "$f" | sed -e "s,^m4/,$cached_m4base/,"` ;;
-      tests/*) g=`echo "$f" | sed -e "s,^tests/,$cached_testsbase/,"` ;;
-      *) g="$f" ;;
-    esac
-    echo "$g""$delimiter""$f"
-  done | LC_ALL=C sort > "$tmp"/old-files
-  for f in $new_files; do
-    case "$f" in
-      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
-      doc/*) g=`echo "$f" | sed -e "s,^doc/,$docbase/,"` ;;
-      lib/*) g=`echo "$f" | sed -e "s,^lib/,$sourcebase/,"` ;;
-      m4/*) g=`echo "$f" | sed -e "s,^m4/,$m4base/,"` ;;
-      tests/*) g=`echo "$f" | sed -e "s,^tests/,$testsbase/,"` ;;
-      *) g="$f" ;;
-    esac
-    echo "$g""$delimiter""$f"
-  done | LC_ALL=C sort > "$tmp"/new-files
+  sed_rewrite_old_files="\
+    s,^build-aux/,$auxdir/,
+    s,^doc/,$cached_docbase/,
+    s,^lib/,$cached_sourcebase/,
+    s,^m4/,$cached_m4base/,
+    s,^tests/,$cached_testsbase/,"
+  sed_rewrite_new_files="\
+    s,^build-aux/,$auxdir/,
+    s,^doc/,$docbase/,
+    s,^lib/,$sourcebase/,
+    s,^m4/,$m4base/,
+    s,^tests/,$testsbase/,"
+  # Construct a table with 2 columns: rewritten-file-name original-file-name,
+  # representing the files according to the last gnulib-tool invocation.
+  for f in $old_files; do echo $f; done \
+    | sed -e "s,^.*\$,&$delimiter&," -e "$sed_rewrite_old_files" \
+    | LC_ALL=C sort \
+    > "$tmp"/old-files
+  # Construct a table with 2 columns: rewritten-file-name original-file-name,
+  # representing the files after this gnulib-tool invocation.
+  for f in $new_files; do echo $f; done \
+    | sed -e "s,^.*\$,&$delimiter&," -e "$sed_rewrite_new_files" \
+    | LC_ALL=C sort \
+    > "$tmp"/new-files
   # First the files that are in old-files, but not in new-files:
   sed_take_first_column='s,'"$delimiter"'.*,,'
   for g in `LC_ALL=C join -t"$delimiter" -v1 "$tmp"/old-files "$tmp"/new-files | sed -e "$sed_take_first_column"`; do
@@ -1314,18 +1622,19 @@ func_import ()
     fi
   done
   # func_add_or_update handles a file that ought to be present afterwards.
-  # Uses parameters f, g, already_present.
+  # Uses parameters
+  # - f             the original file name
+  # - g             the rewritten file name
+  # - already_present  nonempty if the file already exists, empty otherwise
   func_add_or_update ()
   {
     func_dest_tmpfilename "$g"
     func_lookup_file "$f"
     cp "$lookedup_file" "$tmpfile" || func_fatal_error "failed"
-    if test -n "$lgpl"; then
-      # Update license.
+    if test -n "$sed_transform_lib_file"; then
       case "$f" in
         lib/*)
-          sed -e 's/GNU General/GNU Lesser General/g' \
-              -e 's/version 2\([ ,]\)/version 2.1\1/g' \
+          sed -e "$sed_transform_lib_file" \
             < "$lookedup_file" > "$tmpfile" || func_fatal_error "failed"
           ;;
       esac
@@ -1378,75 +1687,88 @@ func_import ()
   # Then the files that are in new-files, but not in old-files:
   sed_take_last_column='s,^.*'"$delimiter"',,'
   already_present=
-  for f in `LC_ALL=C join -t"$delimiter" -v2 "$tmp"/old-files "$tmp"/new-files | sed -e "$sed_take_last_column"`; do
-    case "$f" in
-      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
-      doc/*) g=`echo "$f" | sed -e "s,^doc/,$docbase/,"` ;;
-      lib/*) g=`echo "$f" | sed -e "s,^lib/,$sourcebase/,"` ;;
-      m4/*) g=`echo "$f" | sed -e "s,^m4/,$m4base/,"` ;;
-      tests/*) g=`echo "$f" | sed -e "s,^tests/,$testsbase/,"` ;;
-      *) g="$f" ;;
-    esac
-    func_add_or_update
-  done
+  LC_ALL=C join -t"$delimiter" -v2 "$tmp"/old-files "$tmp"/new-files \
+    | sed -e "$sed_take_last_column" \
+    | sed -e "s,^.*\$,&$delimiter&," -e "$sed_rewrite_new_files" > "$tmp"/added-files
+  { # Rearrange file descriptors. Needed because "while ... done < ..."
+    # constructs are executed in a subshell e.g. by Solaris 10 /bin/sh.
+    exec 5<&0 < "$tmp"/added-files
+    while read g f; do
+      func_add_or_update
+    done
+    exec 0<&5 5<&-
+  }
   # Then the files that are in new-files and in old-files:
   already_present=true
-  for f in `LC_ALL=C join -t"$delimiter" "$tmp"/old-files "$tmp"/new-files | sed -e "$sed_take_last_column"`; do
-    case "$f" in
-      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
-      doc/*) g=`echo "$f" | sed -e "s,^doc/,$docbase/,"` ;;
-      lib/*) g=`echo "$f" | sed -e "s,^lib/,$sourcebase/,"` ;;
-      m4/*) g=`echo "$f" | sed -e "s,^m4/,$m4base/,"` ;;
-      tests/*) g=`echo "$f" | sed -e "s,^tests/,$testsbase/,"` ;;
-      *) g="$f" ;;
-    esac
-    func_add_or_update
-  done
+  LC_ALL=C join -t"$delimiter" "$tmp"/old-files "$tmp"/new-files \
+    | sed -e "$sed_take_last_column" \
+    | sed -e "s,^.*\$,&$delimiter&," -e "$sed_rewrite_new_files" > "$tmp"/kept-files
+  { # Rearrange file descriptors. Needed because "while ... done < ..."
+    # constructs are executed in a subshell e.g. by Solaris 10 /bin/sh.
+    exec 5<&0 < "$tmp"/kept-files
+    while read g f; do
+      func_add_or_update
+    done
+    exec 0<&5 5<&-
+  }
 
   # Command-line invocation printed in a comment in generated gnulib-cache.m4.
   actioncmd="gnulib-tool --import"
-  actioncmd="$actioncmd --dir=$destdir"
-  actioncmd="$actioncmd --lib=$libname"
-  actioncmd="$actioncmd --source-base=$sourcebase"
-  actioncmd="$actioncmd --m4-base=$m4base"
-  actioncmd="$actioncmd --doc-base=$docbase"
-  actioncmd="$actioncmd --aux-dir=$auxdir"
+  func_append actioncmd " --dir=$destdir"
+  if test -n "$local_gnulib_dir"; then
+    func_append actioncmd " --local-dir=$local_gnulib_dir"
+  fi
+  func_append actioncmd " --lib=$libname"
+  func_append actioncmd " --source-base=$sourcebase"
+  func_append actioncmd " --m4-base=$m4base"
+  func_append actioncmd " --doc-base=$docbase"
+  func_append actioncmd " --aux-dir=$auxdir"
   for module in $avoidlist; do
-    actioncmd="$actioncmd --avoid=$module"
+    func_append actioncmd " --avoid=$module"
   done
   if test -n "$lgpl"; then
-    actioncmd="$actioncmd --lgpl"
+    func_append actioncmd " --lgpl"
+  fi
+  if test -n "$makefile_name"; then
+    func_append actioncmd " --makefile_name=$makefile_name"
   fi
   if test "$libtool" = true; then
-    actioncmd="$actioncmd --libtool"
+    func_append actioncmd " --libtool"
   else
-    actioncmd="$actioncmd --no-libtool"
+    func_append actioncmd " --no-libtool"
   fi
-  actioncmd="$actioncmd --macro-prefix=$macro_prefix"
-  actioncmd="$actioncmd `echo $specified_modules`"
+  func_append actioncmd " --macro-prefix=$macro_prefix"
+  func_append actioncmd " `echo $specified_modules`"
 
-  # Create lib/Makefile.am.
-  func_dest_tmpfilename $sourcebase/Makefile.am
+  # Default the makefile name to Makefile.am.
+  if test -n "$makefile_name"; then
+    makefile_am=$makefile_name
+  else
+    makefile_am=Makefile.am
+  fi
+
+  # Create library makefile.
+  func_dest_tmpfilename $sourcebase/$makefile_am
   func_emit_lib_Makefile_am > "$tmpfile"
-  if test -f "$destdir"/$sourcebase/Makefile.am; then
-    if cmp "$destdir"/$sourcebase/Makefile.am "$tmpfile" > /dev/null; then
+  if test -f "$destdir"/$sourcebase/$makefile_am; then
+    if cmp "$destdir"/$sourcebase/$makefile_am "$tmpfile" > /dev/null; then
       rm -f "$tmpfile"
     else
       if $doit; then
-        echo "Updating $sourcebase/Makefile.am (backup in $sourcebase/Makefile.am~)"
-        mv -f "$destdir"/$sourcebase/Makefile.am "$destdir"/$sourcebase/Makefile.am~
-        mv -f "$tmpfile" "$destdir"/$sourcebase/Makefile.am
+        echo "Updating $sourcebase/$makefile_am (backup in $sourcebase/$makefile_am~)"
+        mv -f "$destdir"/$sourcebase/$makefile_am "$destdir"/$sourcebase/$makefile_am~
+        mv -f "$tmpfile" "$destdir"/$sourcebase/$makefile_am
       else
-        echo "Update $sourcebase/Makefile.am (backup in $sourcebase/Makefile.am~)"
+        echo "Update $sourcebase/$makefile_am (backup in $sourcebase/$makefile_am~)"
         rm -f "$tmpfile"
       fi
     fi
   else
     if $doit; then
-      echo "Creating $sourcebase/Makefile.am"
-      mv -f "$tmpfile" "$destdir"/$sourcebase/Makefile.am
+      echo "Creating $sourcebase/$makefile_am"
+      mv -f "$tmpfile" "$destdir"/$sourcebase/$makefile_am
     else
-      echo "Create $sourcebase/Makefile.am"
+      echo "Create $sourcebase/$makefile_am"
       rm -f "$tmpfile"
     fi
   fi
@@ -1466,6 +1788,20 @@ func_import ()
     echo "#   $actioncmd"
     echo
     echo "# Specification in the form of a few gnulib-tool.m4 macro invocations:"
+    # Store the local_gnulib_dir relative to destdir.
+    case "$local_gnulib_dir" in
+      "" | /*)
+        relative_local_gnulib_dir="$local_gnulib_dir" ;;
+      * )
+        case "$destdir" in
+          /*) relative_local_gnulib_dir="$local_gnulib_dir" ;;
+          *)
+            # destdir, local_gnulib_dir are both relative.
+            func_relativize "$destdir" "$local_gnulib_dir"
+            relative_local_gnulib_dir="$reldir" ;;
+        esac ;;
+    esac
+    echo "gl_LOCAL_DIR([$relative_local_gnulib_dir])"
     echo "gl_MODULES(["`echo $specified_modules`"])"
     echo "gl_AVOID([$avoidlist])"
     echo "gl_SOURCE_BASE([$sourcebase])"
@@ -1474,6 +1810,7 @@ func_import ()
     echo "gl_TESTS_BASE([$testsbase])"
     echo "gl_LIB([$libname])"
     test -z "$lgpl" || echo "gl_LGPL"
+    echo "gl_MAKEFILE_NAME([$makefile_name])"
     if test "$libtool" = true; then
       echo "gl_LIBTOOL"
     fi
@@ -1511,6 +1848,7 @@ func_import ()
   # Create m4/gnulib-comp.m4.
   func_dest_tmpfilename $m4base/gnulib-comp.m4
   (
+    echo "# DO NOT EDIT! GENERATED AUTOMATICALLY!"
     func_emit_copyright_notice
     echo "#"
     echo "# This file represents the compiled summary of the specification in"
@@ -1524,6 +1862,8 @@ func_import ()
     echo "# any checks for libraries, header files, types and library functions."
     echo "AC_DEFUN([${macro_prefix}_EARLY],"
     echo "["
+    echo "  m4_pattern_forbid([^gl_[A-Z]])dnl the gnulib macro namespace"
+    echo "  m4_pattern_allow([^gl_ES$])dnl a valid locale name"
     echo "  AC_REQUIRE([AC_PROG_RANLIB])"
     if grep AC_GNU_SOURCE "$destdir"/$m4base/*.m4 >/dev/null 2>/dev/null; then
       echo "  AC_REQUIRE([AC_GNU_SOURCE])"
@@ -1532,7 +1872,7 @@ func_import ()
       echo "  AC_REQUIRE([gl_USE_SYSTEM_EXTENSIONS])"
     fi
     if grep gl_LOCK "$destdir"/$m4base/*.m4 >/dev/null 2>/dev/null; then
-      echo "  AC_REQUIRE([gl_LOCK])"
+      echo "  AC_REQUIRE([gl_LOCK_EARLY])"
     fi
     echo "])"
     echo
@@ -1542,9 +1882,14 @@ func_import ()
     echo "["
     if test "$libtool" = true; then
       echo "  AM_CONDITIONAL([GL_COND_LIBTOOL], [true])"
+      echo "  gl_cond_libtool=true"
     else
       echo "  AM_CONDITIONAL([GL_COND_LIBTOOL], [false])"
+      echo "  gl_cond_libtool=false"
+      echo "  gl_libdeps="
+      echo "  gl_ltlibdeps="
     fi
+    echo "  gl_source_base='$sourcebase'"
     if test "$auxdir" != "build-aux"; then
       sed_replace_build_aux='
         :a
@@ -1571,6 +1916,15 @@ func_import ()
         fi
       fi
     done
+    # _LIBDEPS and _LTLIBDEPS variables are not needed if this library is
+    # created using libtool, because libtool already handles the dependencies.
+    if test "$libtool" != true; then
+      libname_upper=`echo "$libname" | tr 'a-z' 'A-Z'`
+      echo "  ${libname_upper}_LIBDEPS=\"\$gl_libdeps\""
+      echo "  AC_SUBST([${libname_upper}_LIBDEPS])"
+      echo "  ${libname_upper}_LTLIBDEPS=\"\$gl_ltlibdeps\""
+      echo "  AC_SUBST([${libname_upper}_LTLIBDEPS])"
+    fi
     echo "])"
     echo
     echo "# This macro records the list of files which have been installed by"
@@ -1609,28 +1963,28 @@ func_import ()
   fi
 
   if test -n "$inctests"; then
-    # Create tests/Makefile.am.
-    func_dest_tmpfilename $testsbase/Makefile.am
+    # Create tests makefile.
+    func_dest_tmpfilename $testsbase/$makefile_am
     func_emit_tests_Makefile_am > "$tmpfile"
-    if test -f "$destdir"/$testsbase/Makefile.am; then
-      if cmp "$destdir"/$testsbase/Makefile.am "$tmpfile" > /dev/null; then
+    if test -f "$destdir"/$testsbase/$makefile_am; then
+      if cmp "$destdir"/$testsbase/$makefile_am "$tmpfile" > /dev/null; then
         rm -f "$tmpfile"
       else
         if $doit; then
-          echo "Updating $testsbase/Makefile.am (backup in $testsbase/Makefile.am~)"
-          mv -f "$destdir"/$testsbase/Makefile.am "$destdir"/$testsbase/Makefile.am~
-          mv -f "$tmpfile" "$destdir"/$testsbase/Makefile.am
+          echo "Updating $testsbase/$makefile_am (backup in $testsbase/$makefile_am~)"
+          mv -f "$destdir"/$testsbase/$makefile_am "$destdir"/$testsbase/$makefile_am~
+          mv -f "$tmpfile" "$destdir"/$testsbase/$makefile_am
         else
-          echo "Update $testsbase/Makefile.am (backup in $testsbase/Makefile.am~)"
+          echo "Update $testsbase/$makefile_am (backup in $testsbase/$makefile_am~)"
           rm -f "$tmpfile"
         fi
       fi
     else
       if $doit; then
-        echo "Creating $testsbase/Makefile.am"
-        mv -f "$tmpfile" "$destdir"/$testsbase/Makefile.am
+        echo "Creating $testsbase/$makefile_am"
+        mv -f "$tmpfile" "$destdir"/$testsbase/$makefile_am
       else
-        echo "Create $testsbase/Makefile.am"
+        echo "Create $testsbase/$makefile_am"
         rm -f "$tmpfile"
       fi
     fi
@@ -1639,43 +1993,53 @@ func_import ()
   echo "Finished."
   echo
   echo "You may need to add #include directives for the following .h files."
+  # First the #include <...> directives without #ifs, sorted for convenience,
+  # then the #include "..." directives without #ifs, sorted for convenience,
+  # then the #include directives that are surrounded by #ifs. Not sorted.
+  for module in $modules; do
+    include_directive=`func_get_include_directive "$module"`
+    case "$nl$include_directive" in
+      *"$nl#if"*)
+        echo "$include_directive" 1>&5
+        ;;
+      *)
+        echo "$include_directive" | grep -v 'include "' 1>&6
+        echo "$include_directive" | grep 'include "' 1>&7
+        ;;
+    esac
+  done 5> "$tmp"/include-if 6> "$tmp"/include-angles 7> "$tmp"/include-quotes
   (
-   # First the #include <...> directives without #ifs, sorted for convenience.
-   for module in $modules; do
-     if func_get_include_directive "$module" | grep '^#if' >/dev/null; then
-       :
-     else
-       func_get_include_directive "$module" | grep -v 'include "'
-     fi
-   done | LC_ALL=C sort -u
-   # Then the #include "..." directives without #ifs, sorted for convenience.
-   for module in $modules; do
-     if func_get_include_directive "$module" | grep '^#if' >/dev/null; then
-       :
-     else
-       func_get_include_directive "$module" | grep 'include "'
-     fi
-   done | LC_ALL=C sort -u
-   # Then the #include directives that are surrounded by #ifs. Not sorted.
-   for module in $modules; do
-     if func_get_include_directive "$module" | grep '^#if' >/dev/null; then
-       func_get_include_directive "$module"
-     fi
-   done
-  ) | sed -e '/^$/d;' -e 's/^/  /'
+   LC_ALL=C sort -u "$tmp"/include-angles
+   LC_ALL=C sort -u "$tmp"/include-quotes
+   cat "$tmp"/include-if
+  ) | sed -e '/^$/d' -e 's/^/  /'
+  rm -f "$tmp"/include-angles "$tmp"/include-quotes "$tmp"/include-if
+
   echo
   echo "Don't forget to"
-  echo "  - add \"$sourcebase/Makefile\" to AC_CONFIG_FILES in $configure_ac,"
+  if test "$makefile_am" = Makefile.am; then
+    echo "  - add \"$sourcebase/Makefile\" to AC_CONFIG_FILES in $configure_ac,"
+  else
+    echo "  - \"include $makefile_name\" from within \"$sourcebase/Makefile.am\","
+  fi
   if test -n "$inctests"; then
-    echo "  - add \"$testsbase/Makefile\" to AC_CONFIG_FILES in $configure_ac,"
+    if test "$makefile_am" = Makefile.am; then
+      echo "  - add \"$testsbase/Makefile\" to AC_CONFIG_FILES in $configure_ac,"
+    else
+      echo "  - \"include $makefile_name\" from within \"$testsbase/Makefile.am\","
+    fi
+  fi
+  if test "$makefile_am" = Makefile.am; then
+    sourcebase_dir=`echo "$sourcebase" | sed -n -e 's,/[^/]*$,/,p'`
+    sourcebase_base=`basename "$sourcebase"`
+    echo "  - mention \"${sourcebase_base}\" in SUBDIRS in ${sourcebase_dir}Makefile.am,"
   fi
-  sourcebase_dir=`echo "$sourcebase" | sed -n -e 's,/[^/]*$,/,p'`
-  sourcebase_base=`basename "$sourcebase"`
-  echo "  - mention \"${sourcebase_base}\" in SUBDIRS in ${sourcebase_dir}Makefile.am,"
   if test -n "$inctests"; then
-    testsbase_dir=`echo "$testsbase" | sed -n -e 's,/[^/]*$,/,p'`
-    testsbase_base=`basename "$testsbase"`
-    echo "  - mention \"${testsbase_base}\" in SUBDIRS in ${testsbase_dir}Makefile.am,"
+    if test "$makefile_am" = Makefile.am; then
+      testsbase_dir=`echo "$testsbase" | sed -n -e 's,/[^/]*$,/,p'`
+      testsbase_base=`basename "$testsbase"`
+      echo "  - mention \"${testsbase_base}\" in SUBDIRS in ${testsbase_dir}Makefile.am,"
+    fi
   fi
   echo "  - mention \"-I ${m4base}\" in ACLOCAL_AMFLAGS in Makefile.am,"
   echo "  - invoke ${macro_prefix}_EARLY in $configure_ac, right after AC_PROG_CC,"
@@ -1684,12 +2048,19 @@ func_import ()
 
 # func_create_testdir testdir modules
 # Input:
+# - local_gnulib_dir  from --local-dir
 # - auxdir          directory relative to destdir where to place build aux files
 func_create_testdir ()
 {
   testdir="$1"
   modules="$2"
-  modules=`for m in $modules; do echo $m; done | LC_ALL=C sort | LC_ALL=C uniq`
+  modules=`for m in $modules; do echo $m; done | LC_ALL=C sort -u`
+
+  # Subdirectory names.
+  sourcebase=gllib
+  m4base=glm4
+  docbase=gldoc
+  testsbase=gltests
 
   # Determine final module list.
   func_modules_transitive_closure
@@ -1706,38 +2077,53 @@ func_create_testdir ()
 
   # Create directories.
   for d in `echo "$files" | sed -n -e 's,^\(.*\)/[^/]*,\1,p'`; do
-    if test "$d" = build-aux; then
-      mkdir -p "$testdir/$auxdir"
-    else
-      mkdir -p "$testdir/$d"
-    fi
+    case "$d" in
+      build-aux) mkdir -p "$testdir/$auxdir" ;;
+      doc)       mkdir -p "$testdir/$docbase" ;;
+      lib)       mkdir -p "$testdir/$sourcebase" ;;
+      m4)        mkdir -p "$testdir/$m4base" ;;
+      tests)     mkdir -p "$testdir/$testsbase" ;;
+      *)         mkdir -p "$testdir/$d" ;;
+    esac
   done
 
   # Copy files or make symbolic links.
-  for f in $files; do
-    func_lookup_file "$f"
-    case "$f" in
-      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
-      *) g="$f" ;;
-    esac
-    if test -n "$lookedup_tmp"; then
-      cp -p "$lookedup_file" "$testdir/$g"
-    else
-      ln "$lookedup_file" "$testdir/$g" 2>/dev/null ||
-      if test -z "$symbolic"; then
+  delimiter='  '
+  sed_rewrite_files="\
+    s,^build-aux/,$auxdir/,
+    s,^doc/,$docbase/,
+    s,^lib/,$sourcebase/,
+    s,^m4/,$m4base/,
+    s,^tests/,$testsbase/,"
+  for f in $files; do echo $f; done \
+    | sed -e "s,^.*\$,&$delimiter&," -e "$sed_rewrite_files" \
+    | LC_ALL=C sort \
+    > "$tmp"/files
+  { # Rearrange file descriptors. Needed because "while ... done < ..."
+    # constructs are executed in a subshell e.g. by Solaris 10 /bin/sh.
+    exec 5<&0 < "$tmp"/files
+    while read g f; do
+      func_lookup_file "$f"
+      if test -n "$lookedup_tmp"; then
         cp -p "$lookedup_file" "$testdir/$g"
       else
-        ln -s "$lookedup_file" "$testdir/$g"
+        ln "$lookedup_file" "$testdir/$g" 2>/dev/null ||
+        if test -z "$symbolic"; then
+          cp -p "$lookedup_file" "$testdir/$g"
+        else
+          ln -s "$lookedup_file" "$testdir/$g"
+        fi
       fi
-    fi
-  done
+    done
+    exec 0<&5 5<&-
+  }
 
-  # Create lib/Makefile.am.
-  mkdir -p "$testdir/lib"
-  func_emit_lib_Makefile_am > "$testdir/lib/Makefile.am"
+  # Create $sourcebase/Makefile.am.
+  mkdir -p "$testdir/$sourcebase"
+  func_emit_lib_Makefile_am > "$testdir/$sourcebase/Makefile.am"
 
-  # Create m4/Makefile.am.
-  mkdir -p "$testdir/m4"
+  # Create $m4base/Makefile.am.
+  mkdir -p "$testdir/$m4base"
   (echo "## Process this file with automake to produce Makefile.in."
    echo
    echo "EXTRA_DIST ="
@@ -1747,28 +2133,25 @@ func_create_testdir ()
          echo "EXTRA_DIST += "`echo "$f" | sed -e 's,^m4/,,'` ;;
      esac
    done
-  ) > "$testdir/m4/Makefile.am"
+  ) > "$testdir/$m4base/Makefile.am"
 
-  subdirs="lib m4"
+  subdirs="$sourcebase $m4base"
   subdirs_with_configure_ac=""
 
-  if test -f "$testdir"/m4/gettext.m4; then
+  if test -f "$testdir"/$m4base/gettext.m4; then
     # Avoid stupid error message from automake:
     # "AM_GNU_GETTEXT used but `po' not in SUBDIRS"
     mkdir -p "$testdir/po"
     (echo "## Process this file with automake to produce Makefile.in."
     ) > "$testdir/po/Makefile.am"
-    subdirs="$subdirs po"
+    func_append subdirs " po"
   fi
 
   if test -n "$inctests"; then
-    test -d "$testdir/tests" || mkdir "$testdir/tests"
-    # Create tests/Makefile.am.
-    sourcebase=lib
-    m4base=m4
-    testsbase=tests
-    func_emit_tests_Makefile_am > "$testdir/tests/Makefile.am"
-    # Create tests/configure.ac.
+    test -d "$testdir/$testsbase" || mkdir "$testdir/$testsbase"
+    # Create $testsbase/Makefile.am.
+    func_emit_tests_Makefile_am > "$testdir/$testsbase/Makefile.am"
+    # Create $testsbase/configure.ac.
     (echo "# Process this file with autoconf to produce a configure script."
      echo "AC_INIT([dummy], [0])"
      echo "AC_CONFIG_AUX_DIR([../$auxdir])"
@@ -1781,23 +2164,36 @@ func_create_testdir ()
      echo "AC_PROG_MAKE_SET"
      echo "AC_PROG_RANLIB"
      echo
-     if grep AC_GNU_SOURCE "$testdir"/m4/*.m4 >/dev/null 2>/dev/null; then
+     if grep AC_GNU_SOURCE "$testdir/$m4base"/*.m4 >/dev/null 2>/dev/null; then
        echo "AC_GNU_SOURCE"
        echo
      fi
-     if grep gl_USE_SYSTEM_EXTENSIONS "$testdir"/m4/*.m4 >/dev/null 2>/dev/null; then
+     if grep gl_USE_SYSTEM_EXTENSIONS "$testdir/$m4base"/*.m4 >/dev/null 2>/dev/null; then
        echo "gl_USE_SYSTEM_EXTENSIONS"
        echo
      fi
-     if grep gl_LOCK "$testdir"/m4/*.m4 >/dev/null 2>/dev/null; then
-       echo "gl_LOCK"
+     if grep gl_LOCK "$testdir/$m4base"/*.m4 >/dev/null 2>/dev/null; then
+       echo "gl_LOCK_EARLY"
        echo
      fi
      if test "$libtool" = true; then
        echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [true])"
+       echo "gl_cond_libtool=true"
      else
        echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [false])"
+       echo "gl_cond_libtool=false"
+       echo "gl_libdeps="
+       echo "gl_ltlibdeps="
      fi
+     echo "gl_source_base='$testsbase'"
+     # Wrap the set of autoconf snippets into an autoconf macro that is then
+     # invoked. This is needed because autoconf does not support AC_REQUIRE
+     # at the top level:
+     #   error: AC_REQUIRE(gt_CSHARPCOMP): cannot be used outside of an AC_DEFUN'd macro
+     # but we want the AC_REQUIRE to have its normal meaning (provide one
+     # expansion of the required macro before the current point, and only one
+     # expansion total).
+     echo "AC_DEFUN([gl_INIT], ["
      if test "$auxdir" != "build-aux"; then
        sed_replace_build_aux='
          :a
@@ -1826,15 +2222,26 @@ func_create_testdir ()
            | sed -e "$sed_replace_build_aux"
        fi
      done
+     # _LIBDEPS and _LTLIBDEPS variables are not needed if this library is
+     # created using libtool, because libtool already handles the dependencies.
+     if test "$libtool" != true; then
+       libname_upper=`echo "$libname" | tr 'a-z' 'A-Z'`
+       echo "  ${libname_upper}_LIBDEPS=\"\$gl_libdeps\""
+       echo "  AC_SUBST([${libname_upper}_LIBDEPS])"
+       echo "  ${libname_upper}_LTLIBDEPS=\"\$gl_ltlibdeps\""
+       echo "  AC_SUBST([${libname_upper}_LTLIBDEPS])"
+     fi
+     echo "])"
+     echo "gl_INIT"
      echo
-     # Usually tests/config.h will be a superset of config.h. Verify this by
-     # "merging" config.h into tests/config.h; look out for gcc warnings.
+     # Usually $testsbase/config.h will be a superset of config.h. Verify this
+     # by "merging" config.h into $testsbase/config.h; look out for gcc warnings.
      echo "AH_TOP([#include \"../config.h\"])"
      echo
      echo "AC_OUTPUT([Makefile])"
-    ) > "$testdir/tests/configure.ac"
-    subdirs="$subdirs tests"
-    subdirs_with_configure_ac="$subdirs_with_configure_ac tests"
+    ) > "$testdir/$testsbase/configure.ac"
+    func_append subdirs " $testsbase"
+    subdirs_with_configure_ac="$subdirs_with_configure_ac $testsbase"
   fi
 
   # Create Makefile.am.
@@ -1844,7 +2251,7 @@ func_create_testdir ()
    echo
    echo "SUBDIRS = $subdirs"
    echo
-   echo "ACLOCAL_AMFLAGS = -I m4"
+   echo "ACLOCAL_AMFLAGS = -I $m4base"
   ) > "$testdir/Makefile.am"
 
   # Create configure.ac.
@@ -1860,25 +2267,42 @@ func_create_testdir ()
    echo "AC_PROG_CC"
    echo "AC_PROG_INSTALL"
    echo "AC_PROG_MAKE_SET"
+   echo
+   echo "m4_pattern_forbid([^gl_[A-Z]])dnl the gnulib macro namespace"
+   echo "m4_pattern_allow([^gl_ES$])dnl a valid locale name"
+   echo
    echo "AC_PROG_RANLIB"
    echo
-   if grep AC_GNU_SOURCE "$testdir"/m4/*.m4 >/dev/null 2>/dev/null; then
+   if grep AC_GNU_SOURCE "$testdir/$m4base"/*.m4 >/dev/null 2>/dev/null; then
      echo "AC_GNU_SOURCE"
      echo
    fi
-   if grep gl_USE_SYSTEM_EXTENSIONS "$testdir"/m4/*.m4 >/dev/null 2>/dev/null; then
+   if grep gl_USE_SYSTEM_EXTENSIONS "$testdir/$m4base"/*.m4 >/dev/null 2>/dev/null; then
      echo "gl_USE_SYSTEM_EXTENSIONS"
      echo
    fi
-   if grep gl_LOCK "$testdir"/m4/*.m4 >/dev/null 2>/dev/null; then
-     echo "gl_LOCK"
+   if grep gl_LOCK "$testdir/$m4base"/*.m4 >/dev/null 2>/dev/null; then
+     echo "gl_LOCK_EARLY"
      echo
    fi
    if test "$libtool" = true; then
      echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [true])"
+     echo "gl_cond_libtool=true"
    else
      echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [false])"
+     echo "gl_cond_libtool=false"
+     echo "gl_libdeps="
+     echo "gl_ltlibdeps="
    fi
+   echo "gl_source_base='$sourcebase'"
+   # Wrap the set of autoconf snippets into an autoconf macro that is then
+   # invoked. This is needed because autoconf does not support AC_REQUIRE
+   # at the top level:
+   #   error: AC_REQUIRE(gt_CSHARPCOMP): cannot be used outside of an AC_DEFUN'd macro
+   # but we want the AC_REQUIRE to have its normal meaning (provide one
+   # expansion of the required macro before the current point, and only one
+   # expansion total).
+   echo "AC_DEFUN([gl_INIT], ["
    if test "$auxdir" != "build-aux"; then
      sed_replace_build_aux='
        :a
@@ -1897,6 +2321,17 @@ func_create_testdir ()
          | sed -e "$sed_replace_build_aux"
      fi
    done
+   # _LIBDEPS and _LTLIBDEPS variables are not needed if this library is
+   # created using libtool, because libtool already handles the dependencies.
+   if test "$libtool" != true; then
+     libname_upper=`echo "$libname" | tr 'a-z' 'A-Z'`
+     echo "  ${libname_upper}_LIBDEPS=\"\$gl_libdeps\""
+     echo "  AC_SUBST([${libname_upper}_LIBDEPS])"
+     echo "  ${libname_upper}_LTLIBDEPS=\"\$gl_ltlibdeps\""
+     echo "  AC_SUBST([${libname_upper}_LTLIBDEPS])"
+   fi
+   echo "])"
+   echo "gl_INIT"
    echo
    if test -n "$subdirs_with_configure_ac"; then
      echo "AC_CONFIG_SUBDIRS(["`echo $subdirs_with_configure_ac`"])"
@@ -1907,7 +2342,7 @@ func_create_testdir ()
      # configure.ac which creates the subdir's Makefile.am, not this one.
      case " $subdirs_with_configure_ac " in
        *" $d "*) ;;
-       *) makefiles="$makefiles $d/Makefile" ;;
+       *) func_append makefiles " $d/Makefile" ;;
      esac
    done
    echo "AC_OUTPUT([$makefiles])"
@@ -1918,10 +2353,10 @@ func_create_testdir ()
    echo "executing ${AUTORECONF} --force --install"
    ${AUTORECONF} --force --install
   )
-  if grep '^BUILT_SOURCES *+=' "$testdir/lib/Makefile.am" > /dev/null; then
+  if grep '^BUILT_SOURCES *+=' "$testdir/$sourcebase/Makefile.am" > /dev/null; then
     (cd "$testdir"
      ./configure
-       cd lib
+       cd "$sourcebase"
        echo 'built_sources: $(BUILT_SOURCES)' >> Makefile
        make built_sources
        cd ..
@@ -1932,6 +2367,7 @@ func_create_testdir ()
 
 # func_create_megatestdir megatestdir allmodules
 # Input:
+# - local_gnulib_dir  from --local-dir
 # - auxdir          directory relative to destdir where to place build aux files
 func_create_megatestdir ()
 {
@@ -1945,13 +2381,14 @@ func_create_megatestdir ()
   # First, all modules one by one.
   for onemodule in $allmodules; do
     func_create_testdir "$megatestdir/$onemodule" $onemodule
-    megasubdirs="${megasubdirs}$onemodule "
+    func_append megasubdirs "$onemodule "
   done
   # Then, all modules all together.
+  # Except config-h, which breaks all modules which use HAVE_CONFIG_H.
   # Except fnmatch-posix, which conflicts with fnmatch-gnu. FIXME.
-  allmodules=`for m in $allmodules; do if test $m != fnmatch-posix; then echo $m; fi; done`
+  allmodules=`for m in $allmodules; do if test $m != config-h && test $m != fnmatch-posix; then echo $m; fi; done`
   func_create_testdir "$megatestdir/ALL" "$allmodules"
-  megasubdirs="${megasubdirs}ALL"
+  func_append megasubdirs "ALL"
 
   # Create Makefile.am.
   (echo "## Process this file with automake to produce Makefile.in."
@@ -2068,7 +2505,7 @@ case $mode in
               /*) ;;
               *)
                 if test -f "$destdir/$arg"/gnulib-cache.m4; then
-                  m4dirs="$m4dirs $arg"
+                  func_append m4dirs " $arg"
                   m4dirs_count=`expr $m4dirs_count + 1`
                 fi
                 ;;
@@ -2087,7 +2524,7 @@ case $mode in
           sedexpr1='s,^m4_include(\[\(.*\)])$,\1,p'
           sedexpr2='s,^[^/]*$,.,'
           sedexpr3='s,/[^/]*$,,'
-          m4dirs=`sed -n -e "$sedexpr1" aclocal.m4 | sed -e "$sedexpr2" -e "$sedexpr3" | LC_ALL=C sort | LC_ALL=C uniq`
+          m4dirs=`sed -n -e "$sedexpr1" aclocal.m4 | sed -e "$sedexpr2" -e "$sedexpr3" | LC_ALL=C sort -u`
           m4dirs_count=`echo "$m4dirs" | wc -l`
         fi
       fi
@@ -2113,7 +2550,12 @@ case $mode in
           if test $# = 0; then
             # No further arguments. Guess the user wants to update all of them.
             for m4base in $m4dirs; do
-              func_import
+              # Perform func_import in a subshell, so that variable values
+              # such as
+              #   local_gnulib_dir, avoidlist, sourcebase, m4base, docbase,
+              #   testsbase, libname, lgpl, makefile_name, libtool, macro_prefix
+              # don't propagate from one directory to another.
+              (func_import) || func_exit 1
             done
           else
             # Really ambiguous.
@@ -2160,7 +2602,7 @@ case $mode in
         if test -n "$remaining"; then
           echo "Remaining files:" $remaining 1>&2
           echo "gnulib-tool: *** Stop." 1>&2
-          exit 1
+          func_exit 1
         fi
       cd ..
     cd ..
@@ -2183,7 +2625,7 @@ case $mode in
         if test -n "$remaining"; then
           echo "Remaining files:" $remaining 1>&2
           echo "gnulib-tool: *** Stop." 1>&2
-          exit 1
+          func_exit 1
         fi
       cd ..
     cd ..
@@ -2286,11 +2728,16 @@ esac
 
 rm -rf "$tmp"
 # Undo the effect of the previous 'trap' command. Some shellology:
-# We cannot use "trap - 0 1 2 3 15", because Solaris sh would attempt to
+# We cannot use "trap - 0 1 2 3 13 15", because Solaris sh would attempt to
 # execute the command "-". "trap '' ..." is fine only for signal 0 (= normal
 # exit); for the others we need to call 'exit' explicitly. The value of $? is
 # 128 + signal number and is set before the trap-registered command is run.
 trap '' 0
-trap 'exit $?' 1 2 3 15
+trap 'func_exit $?' 1 2 3 13 15
 
 exit 0
+
+# Local Variables:
+# indent-tabs-mode: nil
+# whitespace-check-buffer-indent: nil
+# End: